exercises/crud/config/routes.rb
# frozen_string_literal: true

Rails.application.routes.draw do
  root 'home#index'

  resources :tasks
end

exercises/crud/app/models/application_record.rb
# frozen_string_literal: true

class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

exercises/crud/app/models/task.rb
# frozen_string_literal: true
class Task < ApplicationRecord
  validates :name, :status, :creator, presence: true
  validates :status, inclusion: { in: %w[new in_progress testing done], message: '%{value} is not a valid size' }
end

exercises/crud/app/controllers/application_controller.rb
# frozen_string_literal: true

class ApplicationController < ActionController::Base
end

exercises/crud/app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController
  def index; end
end

exercises/crud/app/controllers/tasks_controller.rb
class TasksController < ApplicationController
  def index
    @tasks = Task.all
  end

  def show
    @task = Task.find(params[:id])
  end

  def new
    @task = Task.new(status: 'new')
  end

  def create
    @task = Task.new(task_params)

    if @task.save
      redirect_to task_path(@task)
    else
      render :new
    end
  end

  def edit
    @task = Task.find(params[:id])
  end

  def update
    @task = Task.find(params[:id])

    if @task.update(task_params)
      redirect_to task_path(@task)
    else
      render :edit
    end
  end

  def destroy
    @task = Task.find(params[:id])
    @task.destroy

    redirect_to tasks_path
  end

  private

  def task_params
    params.require(:task).permit(:name, :description, :status, :creator, :performer, :completed)
  end
end

exercises/crud/app/helpers/application_helper.rb
# frozen_string_literal: true

module ApplicationHelper
end

exercises/crud/app/helpers/tasks_helper.rb
module TasksHelper
end

exercises/crud/app/views/home/index.html.erb
<h1>Home#index</h1>

exercises/crud/app/views/tasks/_error.html.erb
<% task.errors.full_messages_for(field).each do |message| %>
  <div class="red"><%= message %></div>
<% end %>

exercises/crud/app/views/tasks/_form.html.erb
<%= form_with model: task do |form| %>
  <div>
    <%= form.label :name %><br>
    <%= form.text_field :name %>
    <%= render "error", task: task, field: :name %>
  </div>

  <div>
    <%= form.label :description %><br>
    <%= form.text_area :description %>
  </div>

  <div>
    <%= form.label :status %><br>
    <%= form.select :status, [%w[new new], %w[in_progress in_progress], %w[testing testing], %w[done done]], selected: @task.status %>
    <%= render "error", task: task, field: :status %>
  </div>

  <div>
    <%= form.label :creator %><br>
    <%= form.text_field :creator %>
    <%= render "error", task: task, field: :creator %>
  </div>

  <div>
    <%= form.label :performer %><br>
    <%= form.text_field :performer %>
  </div>

  <div>
    <%= form.label :completed %><br>
    <%= form.check_box :completed, { checked: @task.completed }, true, false %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

exercises/crud/app/views/tasks/edit.html.erb
<h1>Edit Task</h1>

<%= render "form", task: @task %>

exercises/crud/app/views/tasks/index.html.erb
<% statuses = %w[new in_progress testing done] %>

<h1>Tasks</h1>


<div class="container">
  <% statuses.each do |status| %>
    <div class="column">
      <h1><%= status %></h1>
      <% @tasks.each do |task| %>
        <% if task.status == status %>
          <%= link_to task.name, task_path(task) %>
        <% end %>
      <% end %>
    </div>
  <% end %>
</div>

exercises/crud/app/views/tasks/new.html.erb
<h1>New Task</h1>

<%= render "form", task: @task %>

exercises/crud/app/views/tasks/show.html.erb
<h1>Task: <i><%= @task.name %></i></h1>
<h3>Description</h3>
<p><%= @task.description %></p>
<h3>Status</h3>
<p><%= @task.status %></p>
<h3>Creator</h3>
<p><%= @task.creator %></p>
<h3>Performer</h3>
<p><%= @task.performer %></p>

<ul>
  <li><%= link_to "Edit task", edit_task_path(@task) %></li>
  <li><%= link_to "Delete task", task_path(@task),
                  method: :delete,
                  data: { confirm: "Are you sure?" } %></li>
</ul>